
class ForcePointTrail extends ForcePoint  //extends ForePoint == Erweiterung der ForeCpint Klasse. Alles was die ForcePoint Klasse hat, hat auch die Trail Klasse
                                          //alle neu geschriebenen Funktionen in Trail werden von ForcePoint überschrieben
{
  ArrayList<PVector>  _trail;
  int                 _trailMaxSize = 15;
  float               _dirMult = 2;
  float               _backDirMult = 0.01;
  
  ForcePointTrail(int x,int y,float radius,float damperValue)
  {
    super(x,y,radius,damperValue);  //Konstruktor, super == leitet die neuen Variable an die basisklasse weiter
    
    _trail = new ArrayList<PVector>();
    _trail.add(new PVector(x,y));
  }
  
  void setInput(int mouseX,int mouseY,int extraFlag)
  {
    PVector endPos = lastPoint();
    PVector mouseDist = new PVector(mouseX - endPos.x,mouseY - endPos.y); //mouse distanz
    
    if(mouseDist.mag() <= radius) //chekchen ob die Vektoren im Radius der Beachtung sind.
    {
      float strength = mouseDist.mag() / radius; //stärke == länge der mausdistanz / den radius
      float scaleVal = (5.0 - strength) * _dirMult; //skalierungsfaktor == Wert umkehren. ganz nah gleich 1, weit weg fast 0
      
      if(extraFlag == 1)
        scaleVal *= 5;
      
      mouseDist.normalize(); //einheitslänge wird auf 1 gesetzt
      dir.add(PVector.mult(mouseDist,scaleVal));        //der aktuelle richtungswert wird mit der neuen ablenkung addiert  
    }
  }      
  
  PVector lastPoint()
  {
    return _trail.get(_trail.size() - 1); //mit get bekomme ich jedes Element der Liste zurück. size = länge der liste. Mit dieser Funktion erhalte ich den letzten Punkt in der Liste
  }
  
  void update()
  {
    PVector endPos = lastPoint();  //endpos abgespeicher
    PVector dirBack = PVector.sub(new PVector(posX,posY),endPos);  //richtungsposition minus
    
    dirBack.mult(_backDirMult);  //wie schnell der Vektor wieder zurück geht
    dir.add(dirBack);
    dir.mult(damperValue); //wird immer langsamer dank damper

    PVector newEndPos = PVector.add(dir,endPos); //zu PVector wird die direction mit der endPos addiert
    _trail.add(newEndPos);
    
    // check if list reached the max. length
    if(_trail.size() > _trailMaxSize)
      _trail.remove(0);
    
    
  }
  
  void draw()
  {
    
    PVector pos;
    
    //stroke(2555,0,0,50);    
    stroke(0,44,236,70);
    fill(255,random(100,150),0,50);
 
    beginShape();
    for(int i=0;i < _trail.size();i++)
    {
      pos = _trail.get(i);
      vertex(pos.x,pos.y);
    }
  
    endShape();
  }
  
}
